// $Id: Base64.h,v 1.2 2003/11/25 23:15:52 vern Exp $

#ifndef base64_h
#define base64_h

#include <assert.h>
#include <stdio.h>
#include <string.h>

#include "util.h"
#include "BroString.h"

// Maybe we should have a base class for generic decoders?

class Base64Decoder {
public:
	Base64Decoder();

	// A note on Decode():
	//
	// The input is specified by <len> and <data> and the output
	// buffer by <blen> and <buf>.  If *buf is nil, a buffer of
	// an appropriate size will be new'd and *buf will point
	// to the buffer on return. *blen holds the length of
	// decoded data on return.  The function returns the number of
	// input bytes processed, since the decoding will stop when there
	// is not enough output buffer space.

	int Decode(int len, const char* data, int* blen, char** buf);

	int Done(int* pblen, char** pbuf);
	int HasData() const { return base64_group_next != 0; }

	const char* ErrorMsg() const	{ return error_msg; }
	void IllegalEncoding(const char* msg)
		{ 
		/* strncpy(error_msg, msg, sizeof(error_msg)); */
		run_time(msg);
		}

protected:
	char error_msg[256];

protected:
	char base64_group[4];
	int base64_group_next;
	int base64_padding;
	int base64_after_padding;
};

BroString* decode_base64(BroString* s);

#endif /* base64_h */
